/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingVigenciaDAO;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingVigencia;
import com.rjconsultores.ventaboletos.service.PricingVigenciaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * 
 * @author Rafius
 */
@Service("pricingVigenciaService")
public class PricingVigenciaServiceImpl implements PricingVigenciaService {

	@Autowired
	private PricingVigenciaDAO pricingVigenciaDAO;

	public List<PricingVigencia> obtenerTodos() {
		return pricingVigenciaDAO.obtenerTodos();
	}

	public PricingVigencia obtenerID(Integer id) {
		return pricingVigenciaDAO.obtenerID(id);
	}

	@Transactional
	public PricingVigencia suscribir(PricingVigencia entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Pricing.ATIVO);

		return pricingVigenciaDAO.suscribir(entidad);
	}

	@Transactional
	public PricingVigencia actualizacion(PricingVigencia entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Pricing.ATIVO);

		return pricingVigenciaDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(PricingVigencia entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Pricing.EXCLUIDO);

		pricingVigenciaDAO.actualizacion(entidad);
	}

	public List<PricingVigencia> buscarPorVigencias(PricingVigencia pv) {
		return pricingVigenciaDAO.buscarPorVigencias(pv);
	}

	public Boolean podeSalvar(Pricing pricing, PricingVigencia pricingVigencia, Date inicio, Date fim) {
		return pricingVigenciaDAO.podeSalvar(pricing, pricingVigencia, inicio, fim);
	}

	@Override
	@Transactional
	public void borrar(List<PricingVigencia> pricingVigenciaList) {
		if(pricingVigenciaList != null && !pricingVigenciaList.isEmpty()) {
			for (PricingVigencia pricingVigencia : pricingVigenciaList) {
				borrar(pricingVigencia);
			}
		}
	}
}
